/*
 * APICloud JavaScript Library
 * Copyright (c) 2014 apicloud.com
 */
(function(window) {
    var u = {};
//    u.baseUrl = 'http://appi.lpzhrs.cn';
     u.baseUrl = 'http://192.168.100.56:8889';
    u.uris = true; // true 线上 | false 本地
    var isAndroid = (/android/gi).test(navigator.appVersion);
    var uzStorage = function() {
        var ls = window.localStorage;
        if (isAndroid) {
            ls = os.localStorage();
        }
        return ls;
    };

    function parseArguments(url, data, fnSuc, dataType) {
        if (typeof(data) == 'function') {
            dataType = fnSuc;
            fnSuc = data;
            data = undefined;
        }
        if (typeof(fnSuc) != 'function') {
            dataType = fnSuc;
            fnSuc = undefined;
        }
        return {
            url: url,
            data: data,
            fnSuc: fnSuc,
            dataType: dataType
        };
    };
    /********** 自增 **********/
    u.getYear = function(obj) {
        if (obj == null) return '';
        obj = obj || 'none';
        var date = new Date(obj || null);
        if (obj == 'none') date = new Date();
        return 1900 + date.getYear();
    }
    u.fmtDate = function(obj, cut, month, year) {
        if (obj == null) return '无';
        obj = obj || 'none';
        cut = cut || 1;
        month = month || false;
        year = year || false;
        var date = obj == 'none' ? 'new Date()' : new Date(obj || null);
        var dateN = '' + date;
        if (dateN.substr(0, 1) == 'N') return '';
        var y = 1900 + date.getYear();
        var m = (date.getMonth() + 1) > 9 ? (date.getMonth() + 1) : '0' + (date.getMonth() + 1);
        var d = date.getDate() > 9 ? date.getDate() : '0' + date.getDate();
        var unit = ['-', '-', ''];
        if (cut == 2) {
            unit = ['年', '月', '日'];
        } else if (cut == 3) {
            unit = ['/', '/', ''];
        }
        if (year) {
            return y + (cut != 2 ? '' : unit[0]);
        } else if (month) {
            return y + unit[0] + m + (cut != 2 ? '' : unit[1]);
        } else {
            return y + unit[0] + m + unit[1] + d + unit[2];
        }
    };
    u.pageEmpty = function(isLast) {
        isLast = isLast || false;
        if (($('.page-empty').length > 0) || !isLast) return;
        var dom = '<div class="page-empty">' +
            '<div class="img-box"></div>' +
            '<p>暂无数据</p>' +
        '</div>';
        return dom;
    };
    u.openHtmlPage = function(type, params, others) {
        type = type || 'win';
        // 过滤路径
        if (u.uris) {
            params = JSON.stringify(params);
            params = params.replace(/widget:\/\//g, "/lpApp/");
            params = JSON.parse(params);
        }
        if (type === 'win') { // window
            api.openWin(params);
        } else if (type === 'group') { // frameGroup
            api.openFrameGroup(params, others);
        } else { // frame
            api.openFrame(params);
        }
    };
    // 原生交互
    u.doAppInteractive = function(name) {
        if (userJson) {
            var userJsond = typeof userJson === 'string' ? JSON.parse(userJson) : userJson;
            api.sendEvent({
                name: name,
                extra: {
                    personId: userJsond.personId,
                    idcard: userJsond.userName,
                    accessKey: userJsond.accessKey,
                }
            });
        } else {
            $api.dialogLogin();
        }
    };
    u.jumpPage = function(el, stu, t, name, params) {
        el = $(el);
        stu = stu || '';
        var value = el.attr('url').split('/')[0];
        params = params || {};
        console.log('jumpPage----------------------' + value)
        if (!u.authority(value)) return;
        if (stu === 'window') {
            u.openHtmlPage('win', {
                name: name,
                url: 'widget://html/' + el.attr('url') + '.html',
                pageParam: params
            });
        } else {
            var title = t || el.find('.aui-list-item-inner span').html() || el.find('p').html();
            var bounces = true;
            if (el.attr('bounces') == 'false') bounces = false;
            u.jumpPageGo(stu, {
                title: title,
                url: 'widget://html/' + el.attr('url') + '.html',
                bounces: bounces,
                pageParam: params
            });
        }
    };
    u.jumpPageGo = function(stu, pageParam) {
        stu = stu || '';
        var urls = 'Def';
        if (stu == 'def2') {
            urls = 'Def2';
        } else if (stu == 'headDef3') {
            urls = 'Def3';
        } else if (stu == 'headDef4') {
            urls = 'Def4';
        } else if (stu == 'btnt') {
            urls = 'Btnt';
        } else if (stu == 'btnb') {
            urls = 'Btnb';
        } else if (stu == 'search') {
            urls = 'Search';
        } else if (stu == 'select') {
            urls = 'Select';
        } else if (stu == 'searchselect') {
            urls = 'Shst';
        } else {
            urls = 'Def';
        }
        console.log('jumpPageGo----------------------' + urls)
        u.openHtmlPage('win', {
            name: urls,
            url: 'widget://html/header/head' + urls + '.html',
            pageParam: pageParam
        });
    }
    u.pageHint = function(t, t2, c, s) {
        u.openHtmlPage('win', {
            name: 'headDef4',
            url: 'widget://html/header/headDef4.html',
            bounces: true,
            pageParam: {
                title: t || '社保大厅',
                title2: t2 || '说明',
                url: './feedback.html',
                content: c || '当前页面加载失败，请稍后重试',
                src: s || 'pm-xcbdj'
            }
        });
    }
    u.hintPage = function(msg, img, el) {
        el = el || $('.page-contorl');
        var dom = '<section class="page-pt page-article">' +
             '<div class="page-titleImg">' +
                 '<div class="img-box">' +
                    '<img src="../../image/page/'+(img || 'sbk1')+'.png" alt="" >' +
                 '</div>' +
             '</div>' +
             '<div class="page-article-cb page-acb2 pti2"><p><span>'+(msg || '提交成功！')+'</span></p></div>' +
        '</section>';
        el.html('').empty().append(dom);
    }
    u.hintDoNext = function(msg, btnword, el) {
        el = el || $('.page-contorl');
        // btnword = btnword || '提交';
        // <div class="page-btn">
        //     <button tapmode onclick="thisHintDoNext()">${btnword}</button>
        // </div>;
        var dom = '<section class="page-article">' +
            '<div class="page-article-tb">' +
                '<h4>说明</h4>' +
            '</div>' +
            '<div class="page-article-cb page-acb4">' +
                '<p>'+(msg || '提交成功！')+'</p>' +
            '</div>' +
        '</section>';
        el.html('').empty().append(dom);
    }
    u.randoms = function(min, max) {
        return Math.floor(Math.random() * (max - min + 1)) + min;
    };
    u.authority = function(value) {
        var userJson = u.getStorage('user') || null;
        var array = ['user', 'sbk', 'work', 'talents', 'insurance', 'peGrStop', 'pePay', 'mrPay', 'meWork', 'mePay', 'mrTtbsq', 'mrXcbdj', 'changeTel', 'changePass', 'loss', 'jyInfo', 'userSmrz', 'retireQuery', 'retire'];
        // alert(u.getStorage('user')+'--'+$.inArray(value, array)+'--'+(!u.getStorage('user') && $.inArray(value, array) >= 0));
        // 登录
        if (!userJson && $.inArray(value, array) >= 0) {
            u.dialogLogin();
            return false;
        } else if (userJson && value == 'insurance' && !JSON.parse(userJson).smrz) {
            if ($('.aui-dialog').length) $('.aui-dialog').remove();
            $('.aui-mask').removeClass('aui-mask-in');
            dialog.alert({
                title: "提示",
                msg: '由于您未实名认证，暂时无法访问该页面！',
                buttons: ['取消', '认证']
            }, function(ret) {
                if (ret.buttonIndex == 2) {
                    u.openHtmlPage('win', {
                        name: 'headDef3',
                        url: 'widget://html/header/headDef3.html',
                        pageParam: {
                            title: '个人中心',
                            url: 'widget://html/user/smrz.html',
                        }
                    });
                }
            });
            return false;
        }
        return true;
    }
    u.dialogLogin = function() {
        if ($('.aui-dialog').length) $('.aui-dialog').remove();
        $('.aui-mask').removeClass('aui-mask-in');
        dialog.alert({
            title: "提示",
            msg: "由于您未登录，暂时无法访问该页面！",
            buttons: ['取消', '登录']
        }, function(ret) {
            if (ret.buttonIndex == 2) {
                u.openHtmlPage('win', {
                    name: 'login',
                    url: 'widget://html/account/login.html',
                    softInputMode: 'resize',
                    pageParam: {
                        stu: 'out'
                    }
                });
            }
        });
    }
    u.dialoga = function(msg, btnName, callback, title) {
        // if ($('.aui-dialog').length) $('.aui-dialog').remove();
        // $('.aui-mask').removeClass('aui-mask-in');
        dialog.remove();
        msg = msg || "服务器访问失败，请稍后再试。";
        if (msg == '您的登录已过期，请重新登录') {
            dialog.alert({
                title: "提示",
                msg: msg,
                buttons: ['确定']
            }, function(ret) {
                u.openHtmlPage('win', {
                    name: 'login',
                    url: 'widget://html/account/login.html',
                    softInputMode: 'resize',
                    pageParam: {
                        stu: 'out'
                    }
                });
            });
        }
        // 尚阳
        else if (msg.search('正在同步中') !== -1) {
            // toast
            var ftimed = null;
            clearInterval(ftimed);
            var seconds = 10;
            ftimed = setInterval(function(){
                seconds -= 1;
                if(seconds <= 0){
                    clearInterval(ftimed);
                    if (typeof load === 'function') load();
                }
            },1000);
        } else {
            dialog.alert({
                title: title || "提示",
                msg: msg,
                buttons: [btnName || '确定']
            }, function(){
                if (callback === 'closeWin') {
                    api.closeWin();
                } else if (typeof callback === 'function') {
                    callback();
                    // return false;
                }
            });
        }
    }
    u.toastc = function(t, s) {
        toast.custom({
            title: t || '出错了',
            html: '',
            duration: s || 3000
        });
    }
    u.picker = function(s) {
        s = s || false;
        var datas = [],
            defaultValue = ['-1'];
        if (s == 'true') {
            datas = [{
                label: '全部',
                value: '-1'
            }, {
                label: '未查看',
                value: '0'
            }, {
                label: '已查看',
                value: '1'
            }, {
                label: '面试邀约',
                value: '2'
            }, {
                label: '不合适',
                value: '3'
            }];
        } else if (s == 'type') {
            datas = [{
                label: '全部',
                value: '-1'
            }, {
                label: '个人信息',
                value: '0'
            }, {
                label: '就业创业',
                value: '1'
            }, {
                label: '公共信息',
                value: '2'
            }, {
                label: '社保卡服务',
                value: '3'
            }, {
                label: '社会保险',
                value: '4'
            }];
        } else {
            var date = new Date();
            var year = 1900 + date.getYear() - 2016;
            datas = [{
                label: '全部',
                value: ''
            }];
            for (var i = 0; i <= year; i++) {
                var datel = new Object();
                datel.label = 2016 + year - i + '年';
                datel.value = 2016 + year - i;
                datas.push(datel);
            }
            defaultValue = ['全部'];
        }
        api.setFrameAttr({
            bounces: false
        });
        weui.picker(datas, {
            defaultValue: defaultValue,
            onChange: function(result) {
                api.execScript({
                    script: 'showSelect("' + result[0].label + '", "' + result[0].value + '");'
                });
            },
            onConfirm: function(result) {
                api.execScript({
                    script: 'showSelect("' + result[0].label + '", "' + result[0].value + '");'
                });
                if (s == 'true' || s == 'year') {
                    KeyWord(result[0].value);
                } else {
                    KeyWord(result[0].label);
                }
            },
            onClose: function() {
                api.setFrameAttr({
                    bounces: true
                });
            }
        });
    }
    u.getSex = function(num) {
        if (num === 'no') return '男';
        num = num || JSON.parse($api.getStorage('user')).userName;
        return num[num.length - 2] % 2 ? '男' : '女';
    }
    u.getAge = function(UUserCard) {
        if (UUserCard === 'no') return '无';
        UUserCard = UUserCard || JSON.parse($api.getStorage('user')).userName;
        //获取年龄
        var myDate = new Date();
        var month = myDate.getMonth() + 1;
        var day = myDate.getDate();
        var age = myDate.getFullYear() - UUserCard.substring(6, 10) - 1;
        if (UUserCard.substring(10, 12) < month || UUserCard.substring(10, 12) == month && UUserCard.substring(12, 14) <= day) {
            age++;
        }
        // console.log(age);
        return age;
    }
    // 类型检测
    u.gettyped = function(data){
        var gettype = Object.prototype.toString;
        data = gettype.call(data);
        data = data.split(' ')[1];
        data = data.substr(0, data.length - 1);
        return data;
    }
    // 格式化json
    u.checkSessionsObj = function(str, stu) {
        str = str || '';
        if (!str || str === 'undefined' || str === 'null') {
            return stu === 'Array' ? [] : {};
        } else {
            return JSON.parse(str);
        }
    }
    /**********  库  **********/
    u.trim = function(str) {
        if (String.prototype.trim) {
            return str == null ? "" : String.prototype.trim.call(str);
        } else {
            return str.replace(/(^\s*)|(\s*$)/g, "");
        }
    };
    u.trimAll = function(str) {
        return str.replace(/\s*/g, '');
    };
    u.isElement = function(obj) {
        return !!(obj && obj.nodeType == 1);
    };
    u.isArray = function(obj) {
        if (Array.isArray) {
            return Array.isArray(obj);
        } else {
            return obj instanceof Array;
        }
    };
    u.isEmptyObject = function(obj) {
        if (JSON.stringify(obj) === '{}') {
            return true;
        }
        return false;
    };
    u.addEvt = function(el, name, fn, useCapture) {
        if (!u.isElement(el)) {
            console.warn('$api.addEvt Function need el param, el param must be DOM Element');
            return;
        }
        useCapture = useCapture || false;
        if (el.addEventListener) {
            el.addEventListener(name, fn, useCapture);
        }
    };
    u.rmEvt = function(el, name, fn, useCapture) {
        if (!u.isElement(el)) {
            console.warn('$api.rmEvt Function need el param, el param must be DOM Element');
            return;
        }
        useCapture = useCapture || false;
        if (el.removeEventListener) {
            el.removeEventListener(name, fn, useCapture);
        }
    };
    u.one = function(el, name, fn, useCapture) {
        if (!u.isElement(el)) {
            console.warn('$api.one Function need el param, el param must be DOM Element');
            return;
        }
        useCapture = useCapture || false;
        var that = this;
        var cb = function() {
            fn && fn();
            that.rmEvt(el, name, cb, useCapture);
        };
        that.addEvt(el, name, cb, useCapture);
    };
    u.dom = function(el, selector) {
        if (arguments.length === 1 && typeof arguments[0] == 'string') {
            if (document.querySelector) {
                return document.querySelector(arguments[0]);
            }
        } else if (arguments.length === 2) {
            if (el.querySelector) {
                return el.querySelector(selector);
            }
        }
    };
    u.domAll = function(el, selector) {
        if (arguments.length === 1 && typeof arguments[0] == 'string') {
            if (document.querySelectorAll) {
                return document.querySelectorAll(arguments[0]);
            }
        } else if (arguments.length === 2) {
            if (el.querySelectorAll) {
                return el.querySelectorAll(selector);
            }
        }
    };
    u.byId = function(id) {
        return document.getElementById(id);
    };
    u.first = function(el, selector) {
        if (arguments.length === 1) {
            if (!u.isElement(el)) {
                console.warn('$api.first Function need el param, el param must be DOM Element');
                return;
            }
            return el.children[0];
        }
        if (arguments.length === 2) {
            return this.dom(el, selector + ':first-child');
        }
    };
    u.last = function(el, selector) {
        if (arguments.length === 1) {
            if (!u.isElement(el)) {
                console.warn('$api.last Function need el param, el param must be DOM Element');
                return;
            }
            var children = el.children;
            return children[children.length - 1];
        }
        if (arguments.length === 2) {
            return this.dom(el, selector + ':last-child');
        }
    };
    u.eq = function(el, index) {
        return this.dom(el, ':nth-child(' + index + ')');
    };
    u.not = function(el, selector) {
        return this.domAll(el, ':not(' + selector + ')');
    };
    u.prev = function(el) {
        if (!u.isElement(el)) {
            console.warn('$api.prev Function need el param, el param must be DOM Element');
            return;
        }
        var node = el.previousSibling;
        if (node.nodeType && node.nodeType === 3) {
            node = node.previousSibling;
            return node;
        }
    };
    u.next = function(el) {
        if (!u.isElement(el)) {
            console.warn('$api.next Function need el param, el param must be DOM Element');
            return;
        }
        var node = el.nextSibling;
        if (node.nodeType && node.nodeType === 3) {
            node = node.nextSibling;
            return node;
        }
    };
    u.closest = function(el, selector) {
        if (!u.isElement(el)) {
            console.warn('$api.closest Function need el param, el param must be DOM Element');
            return;
        }
        var doms, targetDom;
        var isSame = function(doms, el) {
            var i = 0,
                len = doms.length;
            for (i; i < len; i++) {
                if (doms[i].isSameNode(el)) {
                    return doms[i];
                }
            }
            return false;
        };
        var traversal = function(el, selector) {
            doms = u.domAll(el.parentNode, selector);
            targetDom = isSame(doms, el);
            while (!targetDom) {
                el = el.parentNode;
                if (el != null && el.nodeType == el.DOCUMENT_NODE) {
                    return false;
                }
                traversal(el, selector);
            }

            return targetDom;
        };

        return traversal(el, selector);
    };
    u.contains = function(parent, el) {
        var mark = false;
        if (el === parent) {
            mark = true;
            return mark;
        } else {
            do {
                el = el.parentNode;
                if (el === parent) {
                    mark = true;
                    return mark;
                }
            } while (el === document.body || el === document.documentElement);

            return mark;
        }

    };
    u.remove = function(el) {
        if (el && el.parentNode) {
            el.parentNode.removeChild(el);
        }
    };
    u.attr = function(el, name, value) {
        if (!u.isElement(el)) {
            console.warn('$api.attr Function need el param, el param must be DOM Element');
            return;
        }
        if (arguments.length == 2) {
            return el.getAttribute(name);
        } else if (arguments.length == 3) {
            el.setAttribute(name, value);
            return el;
        }
    };
    u.removeAttr = function(el, name) {
        if (!u.isElement(el)) {
            console.warn('$api.removeAttr Function need el param, el param must be DOM Element');
            return;
        }
        if (arguments.length === 2) {
            el.removeAttribute(name);
        }
    };
    u.hasCls = function(el, cls) {
        if (!u.isElement(el)) {
            console.warn('$api.hasCls Function need el param, el param must be DOM Element');
            return;
        }
        if (el.className.indexOf(cls) > -1) {
            return true;
        } else {
            return false;
        }
    };
    u.addCls = function(el, cls) {
        if (!u.isElement(el)) {
            console.warn('$api.addCls Function need el param, el param must be DOM Element');
            return;
        }
        if ('classList' in el) {
            el.classList.add(cls);
        } else {
            var preCls = el.className;
            var newCls = preCls + ' ' + cls;
            el.className = newCls;
        }
        return el;
    };
    u.removeCls = function(el, cls) {
        if (!u.isElement(el)) {
            console.warn('$api.removeCls Function need el param, el param must be DOM Element');
            return;
        }
        if ('classList' in el) {
            el.classList.remove(cls);
        } else {
            var preCls = el.className;
            var newCls = preCls.replace(cls, '');
            el.className = newCls;
        }
        return el;
    };
    u.toggleCls = function(el, cls) {
        if (!u.isElement(el)) {
            console.warn('$api.toggleCls Function need el param, el param must be DOM Element');
            return;
        }
        if ('classList' in el) {
            el.classList.toggle(cls);
        } else {
            if (u.hasCls(el, cls)) {
                u.removeCls(el, cls);
            } else {
                u.addCls(el, cls);
            }
        }
        return el;
    };
    u.val = function(el, val) {
        if (!u.isElement(el)) {
            console.warn('$api.val Function need el param, el param must be DOM Element');
            return;
        }
        if (arguments.length === 1) {
            switch (el.tagName) {
                case 'SELECT':
                    var value = el.options[el.selectedIndex].value;
                    return value;
                    break;
                case 'INPUT':
                    return el.value;
                    break;
                case 'TEXTAREA':
                    return el.value;
                    break;
            }
        }
        if (arguments.length === 2) {
            switch (el.tagName) {
                case 'SELECT':
                    el.options[el.selectedIndex].value = val;
                    return el;
                    break;
                case 'INPUT':
                    el.value = val;
                    return el;
                    break;
                case 'TEXTAREA':
                    el.value = val;
                    return el;
                    break;
            }
        }

    };
    u.prepend = function(el, html) {
        if (!u.isElement(el)) {
            console.warn('$api.prepend Function need el param, el param must be DOM Element');
            return;
        }
        el.insertAdjacentHTML('afterbegin', html);
        return el;
    };
    u.append = function(el, html) {
        if (!u.isElement(el)) {
            console.warn('$api.append Function need el param, el param must be DOM Element');
            return;
        }
        el.insertAdjacentHTML('beforeend', html);
        return el;
    };
    u.before = function(el, html) {
        if (!u.isElement(el)) {
            console.warn('$api.before Function need el param, el param must be DOM Element');
            return;
        }
        el.insertAdjacentHTML('beforebegin', html);
        return el;
    };
    u.after = function(el, html) {
        if (!u.isElement(el)) {
            console.warn('$api.after Function need el param, el param must be DOM Element');
            return;
        }
        el.insertAdjacentHTML('afterend', html);
        return el;
    };
    u.html = function(el, html) {
        if (!u.isElement(el)) {
            console.warn('$api.html Function need el param, el param must be DOM Element');
            return;
        }
        if (arguments.length === 1) {
            return el.innerHTML;
        } else if (arguments.length === 2) {
            el.innerHTML = html;
            return el;
        }
    };
    u.text = function(el, txt) {
        if (!u.isElement(el)) {
            console.warn('$api.text Function need el param, el param must be DOM Element');
            return;
        }
        if (arguments.length === 1) {
            return el.textContent;
        } else if (arguments.length === 2) {
            el.textContent = txt;
            return el;
        }
    };
    u.offset = function(el) {
        if (!u.isElement(el)) {
            console.warn('$api.offset Function need el param, el param must be DOM Element');
            return;
        }
        var sl = Math.max(document.documentElement.scrollLeft, document.body.scrollLeft);
        var st = Math.max(document.documentElement.scrollTop, document.body.scrollTop);

        var rect = el.getBoundingClientRect();
        return {
            l: rect.left + sl,
            t: rect.top + st,
            w: el.offsetWidth,
            h: el.offsetHeight
        };
    };
    u.css = function(el, css) {
        if (!u.isElement(el)) {
            console.warn('$api.css Function need el param, el param must be DOM Element');
            return;
        }
        if (typeof css == 'string' && css.indexOf(':') > 0) {
            el.style && (el.style.cssText += ';' + css);
        }
    };
    u.cssVal = function(el, prop) {
        if (!u.isElement(el)) {
            console.warn('$api.cssVal Function need el param, el param must be DOM Element');
            return;
        }
        if (arguments.length === 2) {
            var computedStyle = window.getComputedStyle(el, null);
            return computedStyle.getPropertyValue(prop);
        }
    };
    u.jsonToStr = function(json) {
        if (typeof json === 'object') {
            return JSON && JSON.stringify(json);
        }
    };
    u.strToJson = function(str) {
        if (typeof str === 'string') {
            return JSON && JSON.parse(str);
        }
    };
    u.setStorage = function(key, value) {
        if (arguments.length === 2) {
            var v = value;
            if (typeof v == 'object') {
                v = JSON.stringify(v);
                v = 'obj-' + v;
            } else {
                v = 'str-' + v;
            }
            var ls = uzStorage();
            if (ls) {
                ls.setItem(key, v);
            }
        }
    };
    u.getStorage = function(key) {
        var ls = uzStorage();
        if (ls) {
            var v = ls.getItem(key);
            if (!v) {
                return;
            }
            if (v.indexOf('obj-') === 0) {
                v = v.slice(4);
                return JSON.parse(v);
            } else if (v.indexOf('str-') === 0) {
                return v.slice(4);
            }
        }
    };
    u.rmStorage = function(key) {
        var ls = uzStorage();
        if (ls && key) {
            ls.removeItem(key);
        }
    };
    u.clearStorage = function() {
        var ls = uzStorage();
        if (ls) {
            ls.clear();
        }
    };
    u.fixIos7Bar = function(el) {
        return u.fixStatusBar(el);
    };
    u.fixStatusBar = function(el) {
        if (!u.isElement(el)) {
            console.warn('$api.fixStatusBar Function need el param, el param must be DOM Element');
            return 0;
        }
        fontSizeStore = fontSizeStore || 20;
        el.style.paddingTop = api.safeArea.top * fontSizeStore / 20 + 'px';
        return el.offsetHeight;
    };
    u.fixTabBar = function(el) {
        if (!u.isElement(el)) {
            console.warn('$api.fixTabBar Function need el param, el param must be DOM Element');
            return 0;
        }
        el.style.paddingBottom = api.safeArea.bottom + 'px';
        return el.offsetHeight;
    };
    u.toast = function(title, text, time) {
        var opts = {};
        var show = function(opts, time) {
            api.showProgress(opts);
            setTimeout(function() {
                api.hideProgress();
            }, time);
        };
        if (arguments.length === 1) {
            var time = time || 500;
            if (typeof title === 'number') {
                time = title;
            } else {
                opts.title = title + '';
            }
            show(opts, time);
        } else if (arguments.length === 2) {
            var time = time || 500;
            var text = text;
            if (typeof text === "number") {
                var tmp = text;
                time = tmp;
                text = null;
            }
            if (title) {
                opts.title = title;
            }
            if (text) {
                opts.text = text;
            }
            show(opts, time);
        }
        if (title) {
            opts.title = title;
        }
        if (text) {
            opts.text = text;
        }
        time = time || 500;
        show(opts, time);
    };
    u.post = function( /*url,data,fnSuc,dataType*/ ) {
        var argsToJson = parseArguments.apply(null, arguments);
        var json = {};
        var fnSuc = argsToJson.fnSuc;
        argsToJson.url && (json.url = argsToJson.url);
        argsToJson.data && (json.data = argsToJson.data);
        if (argsToJson.dataType) {
            var type = argsToJson.dataType.toLowerCase();
            if (type == 'text' || type == 'json') {
                json.dataType = type;
            }
        } else {
            json.dataType = 'json';
        }
        json.method = 'post';
        api.ajax(json,
            function(ret, err) {
                if (ret) {
                    fnSuc && fnSuc(ret);
                }
            }
        );
    };
    u.get = function( /*url,fnSuc,dataType*/ ) {
        var argsToJson = parseArguments.apply(null, arguments);
        var json = {};
        var fnSuc = argsToJson.fnSuc;
        argsToJson.url && (json.url = argsToJson.url);
        //argsToJson.data && (json.data = argsToJson.data);
        if (argsToJson.dataType) {
            var type = argsToJson.dataType.toLowerCase();
            if (type == 'text' || type == 'json') {
                json.dataType = type;
            }
        } else {
            json.dataType = 'text';
        }
        json.method = 'get';
        api.ajax(json,
            function(ret, err) {
                if (ret) {
                    fnSuc && fnSuc(ret);
                }
            }
        );
    };

    /*end*/

    window.$api = u;

})(window);



Date.prototype.format = function(format) {
    //eg:format="yyyy-MM-dd hh:mm:ss";

    if (!format) {
        format = "yyyy-MM-dd hh:mm:ss";
    }

    var o = {
        "M+": this.getMonth() + 1, // month
        "d+": this.getDate(), // day
        "H+": this.getHours(), // hour
        "h+": this.getHours(), // hour
        "m+": this.getMinutes(), // minute
        "s+": this.getSeconds(), // second
        "q+": Math.floor((this.getMonth() + 3) / 3), // quarter
        "S": this.getMilliseconds()
    };

    if (/(y+)/.test(format)) {
        format = format.replace(RegExp.$1, (this.getFullYear() + "")
            .substr(4 - RegExp.$1.length));
    }

    for (var k in o) {
        if (new RegExp("(" + k + ")").test(format)) {
            format = format.replace(RegExp.$1, RegExp.$1.length == 1 ?
                o[k] :
                ("00" + o[k]).substr(("" + o[k]).length));
        }
    }

    return format;
};